/// @file
/// Sital's stld1553 library test functions that use DDC naming.
///
/// Note:
/// - All test functions must adhere the following rules in order to be used with Sitals' TestPlanRunner app:
///   - have the following signature: S16BIT <name-of-test-function> ()
///   - Return the following values:
///     - sitalReturnCode_SUCCESS if function successfully completed.
///     - Negative sitalReturnCode_* if an error condition encountered or function failed.
/// - This demo basically uses DDC function, structure, and constant names, as DDC clients are used to.
///   For such users Sital supplies the <ddc2stld1553.h> header file, which contains conversion definitions for all those DDC names that are supported by Sital.
///   Search below for ENABLE_USAGE_OF_DDC_NAMING to see a sample.

// Description  : A header file for Sital's stld1553 library test functions that have been originally implemented by DDC and by its clients.
// Version      : 1.0.0.0
// Author       : Sital Technology R&D
//
// Modification history:
//

#ifndef TestsByDdcClients_INCLUDED
#define TestsByDdcClients_INCLUDED



#ifdef __cplusplus
extern "C" {
#endif



// Compilation flag definitions.



// constant definitions.



// macro definitions.



// enumeration definitions.



// structure definitions.



// static variables.



// external function declarations.
S16BIT stldTester_Bc_HostBuffer ();
S16BIT stldTester_Bc_Demo ();
S16BIT stldTester_Rt_LegalizationTest ();



#ifdef __cplusplus
}
#endif



#endif // TestsByDdcClients_INCLUDED
