/// @file
/// Sital's stld1553 library test functions that use Sital naming.
///
/// Note:
/// - All test functions must adhere the following rules in order to be used with Sitals' TestPlanRunner app:
///   - have the following signature: S16BIT <name-of-test-function> ()
///   - Return the following values:
///     - sitalReturnCode_SUCCESS if function successfully completed.
///     - Negative sitalReturnCode_* if an error condition encountered or function failed.
/// - This demo basically uses DDC function, structure, and constant names, as DDC clients are used to.
///   For such users Sital supplies the <ddc2stld1553.h> header file, which contains conversion definitions for all those DDC names that are supported by Sital.
///   Search below for ENABLE_USAGE_OF_DDC_NAMING to see a sample.

// Description  : A header file for Sital's stld1553 library test functions.
// Version      : 1.0.0.0
// Author       : Sital Technology R&D
//
// Modification history:
//

#ifndef TestsBySital_INCLUDED
#define TestsBySital_INCLUDED



// Note: The following #ifdef must be commented-out, as test functions may include C++ code.
//#ifdef __cplusplus
//extern "C" {
//#endif



// Compilation flag definitions.
#define DO_ALL_BASIC_ATP_TESTS



// constant definitions.



// macro definitions.



// enumeration definitions.



// structure definitions.



// static variables.



// external function declarations.
S16BIT _DECL stldTester_OpenLog ();
S16BIT _DECL stldTester_CloseLog ();

S16BIT _DECL stldTester_Atp_SetBus1 (int iBus);
S16BIT _DECL stldTester_Atp_SetBus1_A ();
S16BIT _DECL stldTester_Atp_SetBus1_B ();

S16BIT _DECL stldTester_Atp_SetDevice1 (int iDevice);
S16BIT _DECL stldTester_Atp_SetDevice1_000 ();
S16BIT _DECL stldTester_Atp_SetDevice1_001 ();
S16BIT _DECL stldTester_Atp_SetDevice1_002 ();
S16BIT _DECL stldTester_Atp_SetDevice1_003 ();
S16BIT _DECL stldTester_Atp_SetDevice1_004 ();
S16BIT _DECL stldTester_Atp_SetDevice1_005 ();
S16BIT _DECL stldTester_Atp_SetDevice1_006 ();
S16BIT _DECL stldTester_Atp_SetDevice1_007 ();
S16BIT _DECL stldTester_Atp_SetDevice1_008 ();
S16BIT _DECL stldTester_Atp_SetDevice1_009 ();
S16BIT _DECL stldTester_Atp_SetDevice1_010 ();
S16BIT _DECL stldTester_Atp_SetDevice1_011 ();
S16BIT _DECL stldTester_Atp_SetDevice1_002 ();
S16BIT _DECL stldTester_Atp_SetDevice1_013 ();
S16BIT _DECL stldTester_Atp_SetDevice1_014 ();
S16BIT _DECL stldTester_Atp_SetDevice1_015 ();
S16BIT _DECL stldTester_Atp_SetDevice1_016 ();
S16BIT _DECL stldTester_Atp_SetDevice1_017 ();
S16BIT _DECL stldTester_Atp_SetDevice1_018 ();
S16BIT _DECL stldTester_Atp_SetDevice1_019 ();
S16BIT _DECL stldTester_Atp_SetDevice1_020 ();
S16BIT _DECL stldTester_Atp_SetDevice1_021 ();
S16BIT _DECL stldTester_Atp_SetDevice1_022 ();
S16BIT _DECL stldTester_Atp_SetDevice1_023 ();
S16BIT _DECL stldTester_Atp_SetDevice1_024 ();
S16BIT _DECL stldTester_Atp_SetDevice1_025 ();
S16BIT _DECL stldTester_Atp_SetDevice1_026 ();
S16BIT _DECL stldTester_Atp_SetDevice1_027 ();
S16BIT _DECL stldTester_Atp_SetDevice1_028 ();
S16BIT _DECL stldTester_Atp_SetDevice1_029 ();
S16BIT _DECL stldTester_Atp_SetDevice1_030 ();
S16BIT _DECL stldTester_Atp_SetDevice1_031 ();

S16BIT _DECL stldTester_Atp_SetDevice2 (int iDevice);
S16BIT _DECL stldTester_Atp_SetDevice2_000 ();
S16BIT _DECL stldTester_Atp_SetDevice2_001 ();
S16BIT _DECL stldTester_Atp_SetDevice2_002 ();
S16BIT _DECL stldTester_Atp_SetDevice2_003 ();
S16BIT _DECL stldTester_Atp_SetDevice2_004 ();
S16BIT _DECL stldTester_Atp_SetDevice2_005 ();
S16BIT _DECL stldTester_Atp_SetDevice2_006 ();
S16BIT _DECL stldTester_Atp_SetDevice2_007 ();
S16BIT _DECL stldTester_Atp_SetDevice2_008 ();
S16BIT _DECL stldTester_Atp_SetDevice2_009 ();
S16BIT _DECL stldTester_Atp_SetDevice2_010 ();
S16BIT _DECL stldTester_Atp_SetDevice2_011 ();
S16BIT _DECL stldTester_Atp_SetDevice2_002 ();
S16BIT _DECL stldTester_Atp_SetDevice2_013 ();
S16BIT _DECL stldTester_Atp_SetDevice2_014 ();
S16BIT _DECL stldTester_Atp_SetDevice2_015 ();
S16BIT _DECL stldTester_Atp_SetDevice2_016 ();
S16BIT _DECL stldTester_Atp_SetDevice2_017 ();
S16BIT _DECL stldTester_Atp_SetDevice2_018 ();
S16BIT _DECL stldTester_Atp_SetDevice2_019 ();
S16BIT _DECL stldTester_Atp_SetDevice2_020 ();
S16BIT _DECL stldTester_Atp_SetDevice2_021 ();
S16BIT _DECL stldTester_Atp_SetDevice2_022 ();
S16BIT _DECL stldTester_Atp_SetDevice2_023 ();
S16BIT _DECL stldTester_Atp_SetDevice2_024 ();
S16BIT _DECL stldTester_Atp_SetDevice2_025 ();
S16BIT _DECL stldTester_Atp_SetDevice2_026 ();
S16BIT _DECL stldTester_Atp_SetDevice2_027 ();
S16BIT _DECL stldTester_Atp_SetDevice2_028 ();
S16BIT _DECL stldTester_Atp_SetDevice2_029 ();
S16BIT _DECL stldTester_Atp_SetDevice2_030 ();
S16BIT _DECL stldTester_Atp_SetDevice2_031 ();

S16BIT _DECL stldTester_Atp_SetDevice3 (int iDevice);
S16BIT _DECL stldTester_Atp_SetDevice3_000 ();
S16BIT _DECL stldTester_Atp_SetDevice3_001 ();
S16BIT _DECL stldTester_Atp_SetDevice3_002 ();
S16BIT _DECL stldTester_Atp_SetDevice3_003 ();
S16BIT _DECL stldTester_Atp_SetDevice3_004 ();
S16BIT _DECL stldTester_Atp_SetDevice3_005 ();
S16BIT _DECL stldTester_Atp_SetDevice3_006 ();
S16BIT _DECL stldTester_Atp_SetDevice3_007 ();
S16BIT _DECL stldTester_Atp_SetDevice3_008 ();
S16BIT _DECL stldTester_Atp_SetDevice3_009 ();
S16BIT _DECL stldTester_Atp_SetDevice3_010 ();
S16BIT _DECL stldTester_Atp_SetDevice3_011 ();
S16BIT _DECL stldTester_Atp_SetDevice3_002 ();
S16BIT _DECL stldTester_Atp_SetDevice3_013 ();
S16BIT _DECL stldTester_Atp_SetDevice3_014 ();
S16BIT _DECL stldTester_Atp_SetDevice3_015 ();
S16BIT _DECL stldTester_Atp_SetDevice3_016 ();
S16BIT _DECL stldTester_Atp_SetDevice3_017 ();
S16BIT _DECL stldTester_Atp_SetDevice3_018 ();
S16BIT _DECL stldTester_Atp_SetDevice3_019 ();
S16BIT _DECL stldTester_Atp_SetDevice3_020 ();
S16BIT _DECL stldTester_Atp_SetDevice3_021 ();
S16BIT _DECL stldTester_Atp_SetDevice3_022 ();
S16BIT _DECL stldTester_Atp_SetDevice3_023 ();
S16BIT _DECL stldTester_Atp_SetDevice3_024 ();
S16BIT _DECL stldTester_Atp_SetDevice3_025 ();
S16BIT _DECL stldTester_Atp_SetDevice3_026 ();
S16BIT _DECL stldTester_Atp_SetDevice3_027 ();
S16BIT _DECL stldTester_Atp_SetDevice3_028 ();
S16BIT _DECL stldTester_Atp_SetDevice3_029 ();
S16BIT _DECL stldTester_Atp_SetDevice3_030 ();
S16BIT _DECL stldTester_Atp_SetDevice3_031 ();

S16BIT _DECL stldTester_Atp_SetDevice4 (int iDevice);
S16BIT _DECL stldTester_Atp_SetDevice4_000 ();
S16BIT _DECL stldTester_Atp_SetDevice4_001 ();
S16BIT _DECL stldTester_Atp_SetDevice4_002 ();
S16BIT _DECL stldTester_Atp_SetDevice4_003 ();
S16BIT _DECL stldTester_Atp_SetDevice4_004 ();
S16BIT _DECL stldTester_Atp_SetDevice4_005 ();
S16BIT _DECL stldTester_Atp_SetDevice4_006 ();
S16BIT _DECL stldTester_Atp_SetDevice4_007 ();
S16BIT _DECL stldTester_Atp_SetDevice4_008 ();
S16BIT _DECL stldTester_Atp_SetDevice4_009 ();
S16BIT _DECL stldTester_Atp_SetDevice4_010 ();
S16BIT _DECL stldTester_Atp_SetDevice4_011 ();
S16BIT _DECL stldTester_Atp_SetDevice4_002 ();
S16BIT _DECL stldTester_Atp_SetDevice4_013 ();
S16BIT _DECL stldTester_Atp_SetDevice4_014 ();
S16BIT _DECL stldTester_Atp_SetDevice4_015 ();
S16BIT _DECL stldTester_Atp_SetDevice4_016 ();
S16BIT _DECL stldTester_Atp_SetDevice4_017 ();
S16BIT _DECL stldTester_Atp_SetDevice4_018 ();
S16BIT _DECL stldTester_Atp_SetDevice4_019 ();
S16BIT _DECL stldTester_Atp_SetDevice4_020 ();
S16BIT _DECL stldTester_Atp_SetDevice4_021 ();
S16BIT _DECL stldTester_Atp_SetDevice4_022 ();
S16BIT _DECL stldTester_Atp_SetDevice4_023 ();
S16BIT _DECL stldTester_Atp_SetDevice4_024 ();
S16BIT _DECL stldTester_Atp_SetDevice4_025 ();
S16BIT _DECL stldTester_Atp_SetDevice4_026 ();
S16BIT _DECL stldTester_Atp_SetDevice4_027 ();
S16BIT _DECL stldTester_Atp_SetDevice4_028 ();
S16BIT _DECL stldTester_Atp_SetDevice4_029 ();
S16BIT _DECL stldTester_Atp_SetDevice4_030 ();
S16BIT _DECL stldTester_Atp_SetDevice4_031 ();

S16BIT _DECL stldTester_Atp_SetRtAddress1 (int iRtAddress);
S16BIT _DECL stldTester_Atp_SetRtAddress1_00 ();
S16BIT _DECL stldTester_Atp_SetRtAddress1_01 ();
S16BIT _DECL stldTester_Atp_SetRtAddress1_02 ();
S16BIT _DECL stldTester_Atp_SetRtAddress1_03 ();
S16BIT _DECL stldTester_Atp_SetRtAddress1_04 ();
S16BIT _DECL stldTester_Atp_SetRtAddress1_05 ();
S16BIT _DECL stldTester_Atp_SetRtAddress1_06 ();
S16BIT _DECL stldTester_Atp_SetRtAddress1_07 ();
S16BIT _DECL stldTester_Atp_SetRtAddress1_08 ();
S16BIT _DECL stldTester_Atp_SetRtAddress1_09 ();
S16BIT _DECL stldTester_Atp_SetRtAddress1_10 ();
S16BIT _DECL stldTester_Atp_SetRtAddress1_11 ();
S16BIT _DECL stldTester_Atp_SetRtAddress1_02 ();
S16BIT _DECL stldTester_Atp_SetRtAddress1_13 ();
S16BIT _DECL stldTester_Atp_SetRtAddress1_14 ();
S16BIT _DECL stldTester_Atp_SetRtAddress1_15 ();
S16BIT _DECL stldTester_Atp_SetRtAddress1_16 ();
S16BIT _DECL stldTester_Atp_SetRtAddress1_17 ();
S16BIT _DECL stldTester_Atp_SetRtAddress1_18 ();
S16BIT _DECL stldTester_Atp_SetRtAddress1_19 ();
S16BIT _DECL stldTester_Atp_SetRtAddress1_20 ();
S16BIT _DECL stldTester_Atp_SetRtAddress1_21 ();
S16BIT _DECL stldTester_Atp_SetRtAddress1_22 ();
S16BIT _DECL stldTester_Atp_SetRtAddress1_23 ();
S16BIT _DECL stldTester_Atp_SetRtAddress1_24 ();
S16BIT _DECL stldTester_Atp_SetRtAddress1_25 ();
S16BIT _DECL stldTester_Atp_SetRtAddress1_26 ();
S16BIT _DECL stldTester_Atp_SetRtAddress1_27 ();
S16BIT _DECL stldTester_Atp_SetRtAddress1_28 ();
S16BIT _DECL stldTester_Atp_SetRtAddress1_29 ();
S16BIT _DECL stldTester_Atp_SetRtAddress1_30 ();
S16BIT _DECL stldTester_Atp_SetRtAddress1_31 ();

S16BIT _DECL stldTester_Atp_SetRtAddress2 (int iRtAddress);
S16BIT _DECL stldTester_Atp_SetRtAddress2_00 ();
S16BIT _DECL stldTester_Atp_SetRtAddress2_01 ();
S16BIT _DECL stldTester_Atp_SetRtAddress2_02 ();
S16BIT _DECL stldTester_Atp_SetRtAddress2_03 ();
S16BIT _DECL stldTester_Atp_SetRtAddress2_04 ();
S16BIT _DECL stldTester_Atp_SetRtAddress2_05 ();
S16BIT _DECL stldTester_Atp_SetRtAddress2_06 ();
S16BIT _DECL stldTester_Atp_SetRtAddress2_07 ();
S16BIT _DECL stldTester_Atp_SetRtAddress2_08 ();
S16BIT _DECL stldTester_Atp_SetRtAddress2_09 ();
S16BIT _DECL stldTester_Atp_SetRtAddress2_10 ();
S16BIT _DECL stldTester_Atp_SetRtAddress2_11 ();
S16BIT _DECL stldTester_Atp_SetRtAddress2_02 ();
S16BIT _DECL stldTester_Atp_SetRtAddress2_13 ();
S16BIT _DECL stldTester_Atp_SetRtAddress2_14 ();
S16BIT _DECL stldTester_Atp_SetRtAddress2_15 ();
S16BIT _DECL stldTester_Atp_SetRtAddress2_16 ();
S16BIT _DECL stldTester_Atp_SetRtAddress2_17 ();
S16BIT _DECL stldTester_Atp_SetRtAddress2_18 ();
S16BIT _DECL stldTester_Atp_SetRtAddress2_19 ();
S16BIT _DECL stldTester_Atp_SetRtAddress2_20 ();
S16BIT _DECL stldTester_Atp_SetRtAddress2_21 ();
S16BIT _DECL stldTester_Atp_SetRtAddress2_22 ();
S16BIT _DECL stldTester_Atp_SetRtAddress2_23 ();
S16BIT _DECL stldTester_Atp_SetRtAddress2_24 ();
S16BIT _DECL stldTester_Atp_SetRtAddress2_25 ();
S16BIT _DECL stldTester_Atp_SetRtAddress2_26 ();
S16BIT _DECL stldTester_Atp_SetRtAddress2_27 ();
S16BIT _DECL stldTester_Atp_SetRtAddress2_28 ();
S16BIT _DECL stldTester_Atp_SetRtAddress2_29 ();
S16BIT _DECL stldTester_Atp_SetRtAddress2_30 ();
S16BIT _DECL stldTester_Atp_SetRtAddress2_31 ();

S16BIT _DECL stldTester_Atp_SetRtMtModeTest (int iRtMtModeTest);
S16BIT _DECL stldTester_Atp_SetRtMtModeTest_False ();
S16BIT _DECL stldTester_Atp_SetRtMtModeTest_True ();

S16BIT _DECL stldTester_Atp_SetFrameTime (int iFrameTime);
S16BIT _DECL stldTester_Atp_SetIsrPrintoutState (int iIsrPrintoutEnabled);
S16BIT _DECL stldTester_Atp_SetTestIterationsCount (int iTestIterationsCount);

S16BIT _DECL stldTester_BcRtRtMt_FrameContainingAllMessageTypes ();
S16BIT _DECL stldTester_Bc_OpenCloseDevice ();
S16BIT _DECL stldTester_Bc_Isr ();
S16BIT _DECL stldTester_BcRt_DataRxTx ();
S16BIT _DECL stldTester_Bc_HighPriorityAsynchronousMessages ();
S16BIT _DECL stldTester_Bc_LowPriorityAsynchronousMessages ();
S16BIT _DECL stldTester_Bc_TimeTag ();
S16BIT _DECL stldTester_BcMultiRt_DataRxTx ();
S16BIT _DECL stldTester_Atp_DoTest461_11a ();
S16BIT _DECL stldTester_Atp_DoTest461_11b ();
S16BIT _DECL stldTester_Atp_DoTest461_11c ();
S16BIT _DECL stldTester_Atp_DoTest461_11d ();
S16BIT _DECL stldTester_Atp_DoTest461_11e_Isr1_Bit00 ();
S16BIT _DECL stldTester_Atp_DoTest461_11e_Isr1_Bit01 ();
S16BIT _DECL stldTester_Atp_DoTest461_11e_Isr1_Bit02 ();
S16BIT _DECL stldTester_Atp_DoTest461_11e_Isr1_Bit03 ();
S16BIT _DECL stldTester_Atp_DoTest461_11e_Isr1_Bit04 ();
S16BIT _DECL stldTester_Atp_DoTest461_11e_Isr1_Bit06 ();
S16BIT _DECL stldTester_Atp_DoTest461_11e_Isr1_Bit07 ();
S16BIT _DECL stldTester_Atp_DoTest461_11e_Isr1_Bit08 ();
S16BIT _DECL stldTester_Atp_DoTest461_11e_Isr2_Bit00 ();
S16BIT _DECL stldTester_Atp_DoTest461_11e_Isr2_Bit01 ();
S16BIT _DECL stldTester_Atp_DoTest461_11e_Isr2_Bits02To05 ();
S16BIT _DECL stldTester_Atp_DoTest461_11e_Isr2_Bit10 ();
S16BIT _DECL stldTester_Atp_DoTest461_11e_Isr2_Bit11 ();
S16BIT _DECL stldTester_Atp_DoTest461_11e_Isr2_Bit12 ();
S16BIT _DECL stldTester_Atp_DoTest461_11e_Isr2_Bit14 ();
S16BIT _DECL stldTester_Atp_DoTest461_11e_Isr1_Bits10To11_And_Isr2_Bits06To07 ();
S16BIT _DECL stldTester_Atp_DoTest461_11f ();
S16BIT _DECL stldTester_Atp_DoTest461_11g ();
S16BIT _DECL stldTester_Atp_DoTest461_11h ();
S16BIT _DECL stldTester_Atp_DoTest461_11j ();
S16BIT _DECL stldTester_Atp_DoTest461_11k_1 ();
S16BIT _DECL stldTester_Atp_DoTest461_11k_2 ();
S16BIT _DECL stldTester_Atp_DoTest461_11k_3 ();
S16BIT _DECL stldTester_Atp_DoTest461_11k_4 ();
S16BIT _DECL stldTester_Atp_DoTest461_11k_5 ();
S16BIT _DECL stldTester_Atp_DoTest461_11k_6 ();
S16BIT _DECL stldTester_Atp_DoTest461_11l ();
S16BIT _DECL stldTester_Atp_DoTest461_11m_Low ();
S16BIT _DECL stldTester_Atp_DoTest461_11m_High ();
S16BIT _DECL stldTester_Atp_DoTest461_11n ();
S16BIT _DECL stldTester_Atp_DoTest461_13a ();
S16BIT _DECL stldTester_Atp_DoTest461_13b ();
S16BIT _DECL stldTester_Atp_DoTest461_13c ();
S16BIT _DECL stldTester_Atp_DoTest461_13e ();
S16BIT _DECL stldTester_Atp_DoTest461_13e_ExternRt ();
S16BIT _DECL stldTester_Atp_DoTest461_13f ();
S16BIT _DECL stldTester_Atp_DoTest461_13g ();
S16BIT _DECL stldTester_Atp_DoTest461_13h ();
S16BIT _DECL stldTester_Atp_DoTest461_13i ();
S16BIT _DECL stldTester_Atp_DoTest461_13j ();
S16BIT _DECL stldTester_Atp_DoTest461_13k_1 ();
S16BIT _DECL stldTester_Atp_DoTest461_13k_2 ();
S16BIT _DECL stldTester_Atp_DoTest461_13l ();
S16BIT _DECL stldTester_Atp_DoTest461_13m ();
S16BIT _DECL stldTester_Atp_DoTest461_15b ();
S16BIT _DECL stldTester_Atp_DoTest461_15e ();
S16BIT _DECL stldTester_Atp_DoTest461_15f ();
S16BIT _DECL stldTester_Atp_DoTest461_15g ();
S16BIT _DECL stldTester_Atp_DoTest461_15h ();
S16BIT _DECL stldTester_Atp_DoTest461_15i ();
S16BIT _DECL stldTester_Atp_DoTest461_16a ();
S16BIT _DECL stldTester_Atp_DoTest461_EmptyFrame ();
S16BIT _DECL stldTester_BcRt_RtPostSynchronizationBehavior ();
S16BIT _DECL stldTester_Bc_InternalTests ();
S16BIT _DECL stldTester_Bc_ConditionCode ();
S16BIT _DECL temp ();



//#ifdef __cplusplus
//}
//#endif



#endif // TestsBySital_INCLUDED
