// InterProcessSemaphore.h : InterProcessSemaphore declaration
//



#ifndef interProcessSemaphore_INCLUDED
#define interProcessSemaphore_INCLUDED



#ifdef __cplusplus
extern "C" {
#endif



#ifdef MAX_PATH
#define MAX_SEMAPHORE_NAME	MAX_PATH
#else // MAX_PATH undefined
#define MAX_SEMAPHORE_NAME	260
#endif // MAX_PATH



class InterProcessSemaphore
{
	public:

	InterProcessSemaphore (const char* szpName, unsigned int iMaximumCount);
	~InterProcessSemaphore (void);

	bool IsActive (void);
	int Create (void);
	int Open (void);
	int Catch (unsigned int uiWaitTime);
	int Release (void);
	int Close (void);

	private:

	char szName[MAX_SEMAPHORE_NAME + 1]; // A null-terminated string that contains the global name of the semaphore.
	unsigned int uiMaximumCount; // The maximal count of the semaphore, if irrelevant. See further explanation in the constructor.
	bool bIsActive; // A flag that says whether this semaphore has already been created/opened, and wasn't closed since then, so it may be caught and released.

#if defined(WIN32)

	HANDLE hSemaphore; // The handle of the semaphore.

#elif ( defined(__unix__) || defined (VX_WORKS) )

	sem_t* semtspSemaphore; // A pointer to the semaphore structure.

#endif // __unix__ || VX_WORKS

};



#ifdef __cplusplus
}
#endif



#endif // interProcessSemaphore_INCLUDED
