#ifndef stld1553_uniqueStldFefinitions_INCLUDED
#define stld1553_uniqueStldFefinitions_INCLUDED



#ifdef __cplusplus
extern "C" {
#endif



#define sitalBcMaximum_ACTUAL_MESSAGE_BLOCK						10		///< The actual size (in words) of the largest message block, i.e., a RT-to-RT message data block, in device memory.
#define sitalBcCounter_COMMANDS									512		///< Available number of user defined commands per BC.
#define sitalReturnCode_TEST_FAIL											-1010	///< Test failed (though the test function succeeded in performing all its actions).
#define sitalRtDataBlockIrq_NONE				0x0000		///< No IRQs generated.
#define sitalBcFrameIterations_RUN_FOREVER					-1		///< Run a major frame forever.
#define sitalIeee1553_MAXIMUM_COUNT_OF_MESSAGE_DATA_WORDS					32		///< The maximum number of message data words supported by protocol IEEE-1533.

// Return codes.
#define sitalReturnCode_ReadIsqEntry_NO_NEW_ONES							0		///< Found no new entry in the interrupt status queue.
#define sitalReturnCode_ReadIsqEntry_READ_NEW_ENTRY							1		///< Found a single new entry in the interrupt status queue.
#define sitalReturnCode_ReadIsqEntry_READ_NEW_ENTRY_AND_DETECTED_OVERRUN	2		///< Found several new entries in the interrupt status queue, what implies that one or more entries have been lost.
#define sitalReturnCode_ReadGpqEntry_NO_NEW_ONES							0		///< Found no new entry in the general purpose queue.
#define sitalReturnCode_ReadGpqEntry_READ_NEW_ENTRY							1		///< Found a single new entry in the general purpose queue.
#define sitalReturnCode_ReadGpqEntry_READ_NEW_ENTRY_AND_DETECTED_OVERRUN	2		///< Found several new entries in the general purpose queue, what implies that one or more entries have been lost.
#define sitalReturnCode_UNKNOWN_ERROR										-1		///< An unknown error occurred.
#define sitalReturnCode_VERSION_ERROR										-2		///< Failed to get version number.
#define sitalReturnCode_LIBRARY_LOAD_ERROR									-3		///< Failed to load a required function library.
#define sitalReturnCode_SEMAPHORE_OPERATION_ERROR							-4		///< Failed to create or operate semaphore.
#define sitalReturnCode_INVALID_MESSAGE_TYPE								-1000	///< The raw representation of the message couldn't be analyzed.
#define sitalReturnCode_INVALID_RT_ADDRESS									-1001	///< Invalid RT address.
#define sitalReturnCode_INVALID_DIRECTION_BIT								-1002	///< Invalid Rx/Tx selector.
#define sitalReturnCode_INVALID_SUBADDRESS_OR_MODE_SELECTOR					-1003	///< Invalid subaddress/mode selector.
#define sitalReturnCode_INVALID_WORD_COUNT_OR_MODE_CODE						-1004	///< Invalid word-count/mode-code.
#define sitalReturnCode_INVALID_MESSAGE_OPTIONS								-1005	///< Invalid message options.
#define sitalReturnCode_FRAME_NESTING_STACK_OVERFLOW						-1006	///< The maximum number of frame IDs in the nesting stack has been exceeded (see the documentation for function sitalBc_Start).
#define sitalReturnCode_NESTED_MAJOR_FRAME									-1007	///< Same/another major frame is nested within the major frame whose execution is requested.
#define sitalReturnCode_FRAME_NESTING_RECURSION								-1008	///< A minor frame is nested within itself.
#define sitalReturnCode_MESSAGE_NOT_DETECTED								-1009	///< An expected message was not detected.
#define sitalReturnCode_TEST_FAIL											-1010	///< Test failed (though the test function succeeded in performing all its actions).
#define sitalReturnCode_LIMITED_DEVICE										-1011	///< Unsupported by an evaluation device, which is only capable of limited operation.
#define sitalReturnCode_DEVICE_BUSY											-1012	///< Device busy.

// RT manipulation: wRtAddress values.
#define sitalRtAddress_ALL					0xFFFF		///< All RT addresses. (Equivalent DDC definition: ACE_RT_MODIFY_ALL, ACE_MT_FILTER_ALL)
#define sitalRtAddress_0					0			///< RT address 0.
#define sitalRtAddress_1					1			///< RT address 1.
#define sitalRtAddress_2					2			///< RT address 2.
#define sitalRtAddress_3					3			///< RT address 3.
#define sitalRtAddress_4					4			///< RT address 4.
#define sitalRtAddress_5					5			///< RT address 5.
#define sitalRtAddress_6					6			///< RT address 6.
#define sitalRtAddress_7					7			///< RT address 7.
#define sitalRtAddress_8					8			///< RT address 8.
#define sitalRtAddress_9					9			///< RT address 9.
#define sitalRtAddress_10					10			///< RT address 10.
#define sitalRtAddress_11					11			///< RT address 11.
#define sitalRtAddress_12					12			///< RT address 12.
#define sitalRtAddress_13					13			///< RT address 13.
#define sitalRtAddress_14					14			///< RT address 14.
#define sitalRtAddress_15					15			///< RT address 15.
#define sitalRtAddress_16					16			///< RT address 16.
#define sitalRtAddress_17					17			///< RT address 17.
#define sitalRtAddress_18					18			///< RT address 18.
#define sitalRtAddress_19					19			///< RT address 19.
#define sitalRtAddress_20					20			///< RT address 20.
#define sitalRtAddress_21					21			///< RT address 21.
#define sitalRtAddress_22					22			///< RT address 22.
#define sitalRtAddress_23					23			///< RT address 23.
#define sitalRtAddress_24					24			///< RT address 24.
#define sitalRtAddress_25					25			///< RT address 25.
#define sitalRtAddress_26					26			///< RT address 26.
#define sitalRtAddress_27					27			///< RT address 27.
#define sitalRtAddress_28					28			///< RT address 28.
#define sitalRtAddress_29					29			///< RT address 29.
#define sitalRtAddress_30					30			///< RT address 30.
#define sitalRtAddress_31					31			///< RT address 31, which is actually the broadcast address, sital1553_BROADCAST.

// RT manipulation: wSubaddress values.
#define sitalRtSubaddress_0					0			///< RT subaddress 0 (this "subaddress" is actually reserved to designate a mode message, and is not a legal subaddress).
#define sitalRtSubaddress_1					1			///< RT subaddress 1.
#define sitalRtSubaddress_2					2			///< RT subaddress 2.
#define sitalRtSubaddress_3					3			///< RT subaddress 3.
#define sitalRtSubaddress_4					4			///< RT subaddress 4.
#define sitalRtSubaddress_5					5			///< RT subaddress 5.
#define sitalRtSubaddress_6					6			///< RT subaddress 6.
#define sitalRtSubaddress_7					7			///< RT subaddress 7.
#define sitalRtSubaddress_8					8			///< RT subaddress 8.
#define sitalRtSubaddress_9					9			///< RT subaddress 9.
#define sitalRtSubaddress_10				10			///< RT subaddress 10.
#define sitalRtSubaddress_11				11			///< RT subaddress 11.
#define sitalRtSubaddress_12				12			///< RT subaddress 12.
#define sitalRtSubaddress_13				13			///< RT subaddress 13.
#define sitalRtSubaddress_14				14			///< RT subaddress 14.
#define sitalRtSubaddress_15				15			///< RT subaddress 15.
#define sitalRtSubaddress_16				16			///< RT subaddress 16.
#define sitalRtSubaddress_17				17			///< RT subaddress 17.
#define sitalRtSubaddress_18				18			///< RT subaddress 18.
#define sitalRtSubaddress_19				19			///< RT subaddress 19.
#define sitalRtSubaddress_20				20			///< RT subaddress 20.
#define sitalRtSubaddress_21				21			///< RT subaddress 21.
#define sitalRtSubaddress_22				22			///< RT subaddress 22.
#define sitalRtSubaddress_23				23			///< RT subaddress 23.
#define sitalRtSubaddress_24				24			///< RT subaddress 24.
#define sitalRtSubaddress_25				25			///< RT subaddress 25.
#define sitalRtSubaddress_26				26			///< RT subaddress 26.
#define sitalRtSubaddress_27				27			///< RT subaddress 27.
#define sitalRtSubaddress_28				28			///< RT subaddress 28.
#define sitalRtSubaddress_29				29			///< RT subaddress 29.
#define sitalRtSubaddress_30				30			///< RT subaddress 30.
#define sitalRtSubaddress_31				31			///< RT subaddress 31 (this "subaddress" is actually reserved to designate a mode message, and is not a legal subaddress).

//	Register addresses.
#define sitalRegisterAddress_INTERRUPT_MASK_1									0x0000 // R/W
#define sitalRegisterAddress_CONFIGURATION_1									0x0001 // R/W
#define sitalRegisterAddress_CONFIGURATION_2									0x0002 // R/W
#define sitalRegisterAddress_START_OR_RESET										0x0003 //   W
#define sitalRegisterAddress_BC_INSTRUCTION_LIST_POINTER						0x0003 // R
#define sitalRegisterAddress_RT_MT_COMMAND_STACK_POINTER						0x0003 // R
#define sitalRegisterAddress_BC_CONTROL_WORD									0x0004 // R/W
#define sitalRegisterAddress_RT_SUBADDRESS_CONTROL_WORD							0x0004 // R/W
#define sitalRegisterAddress_TIME_TAG											0x0005 // R/W
#define sitalRegisterAddress_INTERRUPT_STATUS_1									0x0006 // R
#define sitalRegisterAddress_CONFIGURATION_3									0x0007 // R/W
#define sitalRegisterAddress_CONFIGURATION_4									0x0008 // R/W
#define sitalRegisterAddress_CONFIGURATION_5									0x0009 // R/W
#define sitalRegisterAddress_RT_MT_DATA_STACK_ADDRESS							0x000A // R/W
#define sitalRegisterAddress_BC_REMAINING_FRAME_TIME							0x000B // R
#define sitalRegisterAddress_BC_INITIAL_INSTRUCTION_POINTER						0x000D // R/W
#define sitalRegisterAddress_RT_LAST_COMMAND									0x000D // R/W
#define sitalRegisterAddress_MT_TRIGGER_WORD									0x000D // R/W
#define sitalRegisterAddress_LIMITATIONS										0x000E // R
#define sitalRegisterAddress_RT_STATUS_WORD										0x000E // R
#define sitalRegisterAddress_RT_BUILT_IN_TEST_WORD								0x000F // R
#define sitalRegisterAddress_CONFIGURATION_6									0x0018 // R/W
#define sitalRegisterAddress_CONFIGURATION_7									0x0019 // R/W
#define sitalRegisterAddress_SITAL_FIRMWARE_VERSION								0x001A // R  
#define sitalRegisterAddress_BC_CONDITION_CODE									0x001B // R  
#define sitalRegisterAddress_BC_GENERAL_PURPOSE_FLAG							0x001B //   W
#define sitalRegisterAddress_INTERRUPT_MASK_2									0x001D // R/W
#define sitalRegisterAddress_INTERRUPT_STATUS_2									0x001E // R
#define sitalRegisterAddress_BC_RT_MT_QUEUE_POINTER								0x001F // R/W
#define sitalRegisterAddress_BC_GENERAL_PURPOSE_QUEUE_POINTER					0x001F // R/W
#define sitalRegisterAddress_RT_MT_INTERRUPT_STATUS_QUEUE_POINTER				0x001F // R/W

// Interrupt mask register #1 masks.
#define sitalInterruptMaskRegister1_END_OF_MESSAGE								0x0001
#define sitalInterruptMaskRegister1_BC_STATUS_SET								0x0002
#define sitalInterruptMaskRegister1_RT_MODE_CODE								0x0002
#define sitalInterruptMaskRegister1_MT_PATTREN_TRIGGER							0x0002
#define sitalInterruptMaskRegister1_FORMAT_ERROR								0x0004
#define sitalInterruptMaskRegister1_BC_END_OF_FRAME								0x0008
#define sitalInterruptMaskRegister1_BC_RT_CONTROL_WORD_END_OF_MESSAGE			0x0010
#define sitalInterruptMaskRegister1_RT_CIRCULAR_BUFFER_ROLLOVER					0x0020
#define sitalInterruptMaskRegister1_TIME_TAG_ROLLOVER							0x0040
#define sitalInterruptMaskRegister1_RT_ADDRESS_PARITY_ERROR						0x0080
#define sitalInterruptMaskRegister1_BC_RETRY									0x0100
#define sitalInterruptMaskRegister1_HANDSHAKE_FAILURE							0x0200
#define sitalInterruptMaskRegister1_MT_DATA_STACK_ROLLOVER						0x0400
#define sitalInterruptMaskRegister1_MT_COMMAND_STACK_ROLLOVER					0x0800
#define sitalInterruptMaskRegister1_BC_RT_COMMAND_STACK_ROLLOVER				0x1000
#define sitalInterruptMaskRegister1_BC_RT_TRANSMITTER_TIMEOUT					0x2000
#define sitalInterruptMaskRegister1_RAM_PARITY_ERROR							0x4000

// Configuration register #1 masks.
#define sitalConfigurationRegister1_FUNCTION_MASK								0xC000
#define sitalConfigurationRegister1_FUNCTION_BC									0x0000
#define sitalConfigurationRegister1_FUNCTION_RT									0x8000
#define sitalConfigurationRegister1_FUNCTION_MT									0x4000

#define sitalConfigurationRegister1_BC_MESSAGE_IN_PROGRESS						0x0001
#define sitalConfigurationRegister1_BC_FRAME_IN_PROGRESS						0x0002
#define sitalConfigurationRegister1_BC_BUSY										0x0004
#define sitalConfigurationRegister1_BC_DOUBLE_RETRY								0x0008
#define sitalConfigurationRegister1_BC_RETRY_ENABLED							0x0010
#define sitalConfigurationRegister1_BC_SINGLE_RETRY_ENABLED						0x0010
#define sitalConfigurationRegister1_BC_DOUBLE_RETRY_ENABLED						0x0018
#define sitalConfigurationRegister1_BC_RETRY_MASK								0x0018
#define sitalConfigurationRegister1_BC_MESSAGE_GAP_TIME_FIELD_ENABLED			0x0020
#define sitalConfigurationRegister1_BC_INTERNAL_TRIGGER_ENABLED					0x0040
#define sitalConfigurationRegister1_BC_EXTERNAL_TRIGGER_ENABLED					0x0080
#define sitalConfigurationRegister1_BC_FRAME_AUTOREPEAT							0x0100
#define sitalConfigurationRegister1_BC_STATUS_SET_STOP_ON_FRAME					0x0200
#define sitalConfigurationRegister1_BC_STATUS_SET_STOP_ON_MESSAGE				0x0400
#define sitalConfigurationRegister1_BC_FRAME_STOP_ON_ERROR						0x0800
#define sitalConfigurationRegister1_BC_MESSAGE_STOP_ON_ERROR					0x1000

#define sitalConfigurationRegister1_RT_MESSAGE_IN_PROGRESS						0x0001
#define sitalConfigurationRegister1_RT_S00										0x0002
#define sitalConfigurationRegister1_RT_S01										0x0004
#define sitalConfigurationRegister1_RT_S02										0x0008
#define sitalConfigurationRegister1_RT_S03										0x0010
#define sitalConfigurationRegister1_RT_S04										0x0020
#define sitalConfigurationRegister1_RT_S05										0x0040
#define sitalConfigurationRegister1_RT_S06										0x0080
#define sitalConfigurationRegister1_RT_FLAG										0x0080
#define sitalConfigurationRegister1_RT_SUBSYSTEM_FLAG							0x0100
#define sitalConfigurationRegister1_RT_SERVICE_REQUEST							0x0200
#define sitalConfigurationRegister1_RT_BUSY										0x0400
#define sitalConfigurationRegister1_RT_DYNAMIC_BUS_CONTROL_ACCEPTANCE			0x0800
#define sitalConfigurationRegister1_RT_MESSAGE_MONITOR_ENABLED					0x1000

#define sitalConfigurationRegister1_MT_ACTIVE									0x0001
#define sitalConfigurationRegister1_MT_TRIGGERED								0x0002
#define sitalConfigurationRegister1_MT_ENABLED									0x0004
#define sitalConfigurationRegister1_MT_EXTERNAL_TRIGGER_ENABLED					0x0080
#define sitalConfigurationRegister1_MT_STOP_ON_TRIGGER							0x0200
#define sitalConfigurationRegister1_MT_START_ON_TRIGGER							0x0400
#define sitalConfigurationRegister1_MT_TRIGGER_WORD_ENABLED						0x0800
#define sitalConfigurationRegister1_MT_MESSAGE_MONITOR_ENABLED					0x1000
#define sitalConfigurationRegister1_MT_ACTIVE_STACK								0x2000

// Configuration register #2 masks.
#define sitalConfigurationRegister2_RT_SEPARATE_BROADCAST_DATA					0x0001
#define sitalConfigurationRegister2_RT_ENHANCED_MEMORY_MANAGEMENT				0x0002
#define sitalConfigurationRegister2_RT_CLEAR_SERVICE_REQUSET					0x0004
#define sitalConfigurationRegister2_LEVEL_OR_PULSE_INTERRUPTS					0x0008
#define sitalConfigurationRegister2_LEVEL_INTERRUPTS							0x0008
#define sitalConfigurationRegister2_INTERRUPT_STATUS_AUTO_CLEAR					0x0010
#define sitalConfigurationRegister2_RT_LOAD_TIME_TAG_ON_SYNCHRONIZE				0x0020
#define sitalConfigurationRegister2_RT_CLEAR_TIME_TAG_ON_SYNCHRONIZE			0x0040
#define sitalConfigurationRegister2_BC_RT_256_WORD_BOUNDRY_DISABLE				0x0400
#define sitalConfigurationRegister2_RT_OVERWRITE_INVALID_DATA					0x0800
#define sitalConfigurationRegister2_RT_SUBADDRESS_DOUBLE_BUFFER					0x1000
#define sitalConfigurationRegister2_RT_BUSY_LOOKUP_TABLE						0x2000
#define sitalConfigurationRegister2_RAM_PARITY									0x4000
#define sitalConfigurationRegister2_ENHANCED_INTERRUPTS							0x8000

#define sitalConfigurationRegister2_TIME_TAG_RESOLUTION_MASK					0x0380
#define sitalConfigurationRegister2_TIME_TAG_2US								0x0280
#define sitalConfigurationRegister2_TIME_TAG_4US								0x0200
#define sitalConfigurationRegister2_TIME_TAG_8US								0x0180
#define sitalConfigurationRegister2_TIME_TAG_16US								0x0100
#define sitalConfigurationRegister2_TIME_TAG_32US								0x0080
#define sitalConfigurationRegister2_TIME_TAG_64US								0x0000
#define sitalConfigurationRegister2_TIME_TAG_TEST								0x0300
#define sitalConfigurationRegister2_TIME_TAG_EXTERNAL_CLOCK						0x0380

// Start/reset register masks.
#define sitalStartResetRegister_RESET											0x0001
#define sitalStartResetRegister_BC_MT_START										0x0002
#define sitalStartResetRegister_INTERRUPT_RESET									0x0004
#define sitalStartResetRegister_TIME_TAG_RESET									0x0008
#define sitalStartResetRegister_TIME_TAG_TEST_CLOCK								0x0010
#define sitalStartResetRegister_BC_STOP_AT_END_OF_FRAME							0x0020
#define sitalStartResetRegister_BC_MT_STOP_AT_END_OF_MESSAGE					0x0040
#define sitalStartResetRegister_INITIATE_PROTOCOL_SELF_TEST						0x0080
#define sitalStartResetRegister_INITIATE_RAM_SELF_TEST							0x0200
#define sitalStartResetRegister_CLEAR_SELF_TEST_REGISTER						0x0400
#define sitalStartResetRegister_CLEAR_RT_HALT									0x0800

// Interrupt status register #1 masks.
#define sitalInterruptStatusRegister1_END_OF_MESSAGE							0x0001
#define sitalInterruptStatusRegister1_BC_STATUS_SET								0x0002
#define sitalInterruptStatusRegister1_RT_MODE_CODE								0x0002
#define sitalInterruptStatusRegister1_MT_PATTERN_TRIGGER						0x0002
#define sitalInterruptStatusRegister1_FORMAT_ERROR								0x0004
#define sitalInterruptStatusRegister1_BC_END_OF_FRAME							0x0008
#define sitalInterruptStatusRegister1_BC_CONTROL_WORD_END_OF_MESSAGE			0x0010
#define sitalInterruptStatusRegister1_RT_SUBADDRESS_END_OF_MESSAGE				0x0010
#define sitalInterruptStatusRegister1_RT_CIRCULAR_BUFFER_ROLLOVER				0x0020
#define sitalInterruptStatusRegister1_TIME_TAG_ROLLOVER							0x0040
#define sitalInterruptStatusRegister1_RT_ADDRESS_PARITY_ERROR					0x0080
#define sitalInterruptStatusRegister1_BC_RETRY									0x0100
#define sitalInterruptStatusRegister1_HANDSHAKE_FAILURE							0x0200
#define sitalInterruptStatusRegister1_MT_DATA_STACK_ROLLOVER					0x0400
#define sitalInterruptStatusRegister1_MT_COMMAND_STACK_ROLLOVER					0x0800
#define sitalInterruptStatusRegister1_BC_RT_COMMAND_STACK_ROLLOVER				0x1000
#define sitalInterruptStatusRegister1_BC_RT_TX_TIMEOUT							0x2000
#define sitalInterruptStatusRegister1_RAM_PARITY_ERROR							0x4000
#define sitalInterruptStatusRegister1_MASTER_INTERRUPT							0x8000

// Configuration register #3 masks.
#define sitalConfigurationRegister3_RT_ENHANCED_MODE_CODE_HANDLING				0x0001
#define sitalConfigurationRegister3_RT_MT_1553A_MODE_CODES						0x0002
#define sitalConfigurationRegister3_RT_FAIL_FLAG_WRAP							0x0004
#define sitalConfigurationRegister3_RT_BUSY_RX_TRANSFER_DISABLE					0x0008
#define sitalConfigurationRegister3_RT_ILLEGAL_RX_TRANSFER_DISABLE				0x0010
#define sitalConfigurationRegister3_RT_ALTERNATE_STATUS_WORD					0x0020
#define sitalConfigurationRegister3_RT_OVERRIDE_MODE_CODE_ERROR					0x0040
#define sitalConfigurationRegister3_RT_ILLEGALIZATION_DISABLED					0x0080
#define sitalConfigurationRegister3_ENHANCED_MODE								0x8000

#define sitalConfigurationRegister3_MT_DATA_STACK_SIZE							0x0700
#define sitalConfigurationRegister3_MT_DATA_STACK_65536							0x0000
#define sitalConfigurationRegister3_MT_DATA_STACK_32768							0x0100
#define sitalConfigurationRegister3_MT_DATA_STACK_16384							0x0200
#define sitalConfigurationRegister3_MT_DATA_STACK_8192							0x0300
#define sitalConfigurationRegister3_MT_DATA_STACK_4096							0x0400
#define sitalConfigurationRegister3_MT_DATA_STACK_2048							0x0500
#define sitalConfigurationRegister3_MT_DATA_STACK_1024							0x0600
#define sitalConfigurationRegister3_MT_DATA_STACK_512							0x0700

#define sitalConfigurationRegister3_MT_COMMAND_STACK_SIZE						0x1800
#define sitalConfigurationRegister3_MT_COMMAND_STACK_256						0x0000
#define sitalConfigurationRegister3_MT_COMMAND_STACK_1024						0x0800
#define sitalConfigurationRegister3_MT_COMMAND_STACK_4096						0x1000
#define sitalConfigurationRegister3_MT_COMMAND_STACK_16384						0x1800

#define sitalConfigurationRegister3_BC_RT_COMMAND_STACK_SIZE					0x6000
#define sitalConfigurationRegister3_BC_RT_COMMAND_STACK_256						0x0000
#define sitalConfigurationRegister3_BC_RT_COMMAND_STACK_512						0x2000
#define sitalConfigurationRegister3_BC_RT_COMMAND_STACK_1024					0x4000
#define sitalConfigurationRegister3_BC_RT_COMMAND_STACK_2048					0x6000

// Configuration register #4 masks.
#define sitalConfigurationRegister4_RT_LATCH_ADDRESS							0x0008
#define sitalConfigurationRegister4_MT_TIME_GAP_OPTION							0x0010
#define sitalConfigurationRegister4_BC_VALID_BUSY_BIT_NO_DATA					0x0020
#define sitalConfigurationRegister4_BC_VALID_MESSAGE_ERROR_BIT_NO_DATA			0x0040
#define sitalConfigurationRegister4_BC_RETRY_BUS_2								0x0080
#define sitalConfigurationRegister4_BC_RETRY_BUS_1								0x0100
#define sitalConfigurationRegister4_BC_RETRY_IF_STATUS_SET						0x0200
#define sitalConfigurationRegister4_BC_RETRY_IF_1553A_AND_MESSAGE_ERROR			0x0400
#define sitalConfigurationRegister4_BC_BROADCAST_MASK_XOR						0x0800
#define sitalConfigurationRegister4_BC_ENHANCED_CONTROL_WORD					0x1000
#define sitalConfigurationRegister4_RT_MODE_CODE_OVERRIDE_BUSY					0x2000
#define sitalConfigurationRegister4_RT_INHIBIT_BUILT_IN_TEST_WORD_IF_BUSY		0x4000
#define sitalConfigurationRegister4_RT_EXTERNAL_BUILT_IN_TEST_WORD				0x8000

#define sitalConfigurationRegister4_TEST_MODE_NORMAL							0x0000
#define sitalConfigurationRegister4_TEST_MODE_DECODER							0x0001
#define sitalConfigurationRegister4_TEST_MODE_ENCODER							0x0002
#define sitalConfigurationRegister4_TEST_MODE_PROTOCOL							0x0003
#define sitalConfigurationRegister4_TEST_MODE_FAIL_SAFE_TIMER					0x0004
#define sitalConfigurationRegister4_TEST_MODE_REGISTER							0x0005
#define sitalConfigurationRegister4_TEST_MODE_TEST								0x0007

// Configuration register #5 masks.
#define sitalConfigurationRegister5_RT_ADDRESS_PARITY							0x0001
#define sitalConfigurationRegister5_RT_ADDRESS_MASK								0x003E
#define sitalConfigurationRegister5_RT_ADDRESS_LATCH							0x0040
#define sitalConfigurationRegister5_RT_MT_BROADCAST_DISABLE						0x0080
#define sitalConfigurationRegister5_GAP_CHECK									0x0100
#define sitalConfigurationRegister5_EXPANDED_CROSSING							0x0800
#define sitalConfigurationRegister5_BC_RT_EXTERNAL_TX_INHIBIT_B					0x1000
#define sitalConfigurationRegister5_BC_RT_EXTERNAL_TX_INHIBIT_A					0x2000
#define sitalConfigurationRegister5_SINGLE_ENDED_SELECT							0x4000
#define sitalConfigurationRegister5_CLOCK_SELECT_MASK							0x8000
#define sitalConfigurationRegister5_CLOCK_SELECT_12MHZ							0x8000
#define sitalConfigurationRegister5_CLOCK_SELECT_16MHZ							0x0000

#define sitalConfigurationRegister5_RESPONSE_TIMEOUT_MASK						0x0600
#define sitalConfigurationRegister5_RESPONSE_TIMEOUT_18US						0x0000
#define sitalConfigurationRegister5_RESPONSE_TIMEOUT_22US						0x0200
#define sitalConfigurationRegister5_RESPONSE_TIMEOUT_50US						0x0400
#define sitalConfigurationRegister5_RESPONSE_TIMEOUT_130US						0x0600

// Limitations register masks.
#define sitalLimitationsRegister_LIMITED_PERFORMANCE							0x8000

// Configuration register #6 masks.
#define sitalConfigurationRegister6_64_WORD_REGISTER_SPACE						0x0004
#define sitalConfigurationRegister6_MT_ENHANCED									0x0010
#define sitalConfigurationRegister6_RT_ADDRESS_SOURCE							0x0020
#define sitalConfigurationRegister6_RT_MT_INTERRUPT_STATUS_QUEUE				0x0040
#define sitalConfigurationRegister6_RT_MT_VALID_MESSAGE_QUEUE_DISABLE			0x0080
#define sitalConfigurationRegister6_RT_MT_INVALID_MESSAGE_QUEUE_DISABLE			0x0100
#define sitalConfigurationRegister6_RT_GLOBAL_CIRCULAR_BUFFER_MASK				0x1000
#define sitalConfigurationRegister6_RT_GLOBAL_CIRCULAR_BUFFER_ENABLE			0x1000
#define sitalConfigurationRegister6_RT_MT_END_OF_MESSAGE_COMMAND_INCREMENT		0x2000
#define sitalConfigurationRegister6_ENHANCED_CPU_ACCESS							0x4000
#define sitalConfigurationRegister6_BC_ENHANCED									0x8000

#define sitalConfigurationRegister6_CLOCK_SELECT_MASK							0x0003
#define sitalConfigurationRegister6_CLOCK_SELECT_16MHZ							0x0000
#define sitalConfigurationRegister6_CLOCK_SELECT_12MHZ							0x0001
#define sitalConfigurationRegister6_CLOCK_SELECT_20MHZ							0x0002
#define sitalConfigurationRegister6_CLOCK_SELECT_10MHZ							0x0003

#define sitalConfigurationRegister6_RT_GLOBAL_CIRCULAR_BUFFER_ENABLE_SIZE_MASK			0x0E00
#define sitalConfigurationRegister6_RT_GLOBAL_CIRCULAR_BUFFER_ENABLE_SIZE_SINGLE		0x0000
#define sitalConfigurationRegister6_RT_GLOBAL_CIRCULAR_BUFFER_ENABLE_SIZE_128			0x0200
#define sitalConfigurationRegister6_RT_GLOBAL_CIRCULAR_BUFFER_ENABLE_SIZE_256			0x0400
#define sitalConfigurationRegister6_RT_GLOBAL_CIRCULAR_BUFFER_ENABLE_SIZE_512			0x0600
#define sitalConfigurationRegister6_RT_GLOBAL_CIRCULAR_BUFFER_ENABLE_SIZE_1024			0x0800
#define sitalConfigurationRegister6_RT_GLOBAL_CIRCULAR_BUFFER_ENABLE_SIZE_2048			0x0A00
#define sitalConfigurationRegister6_RT_GLOBAL_CIRCULAR_BUFFER_ENABLE_SIZE_4096			0x0C00
#define sitalConfigurationRegister6_RT_GLOBAL_CIRCULAR_BUFFER_ENABLE_SIZE_8192			0x0E00

// Configuration register #7 masks.
#define sitalConfigurationRegister7_MODE_CODE_RESET_IN_COMMAND_SELECT			0x0001
#define sitalConfigurationRegister7_BC_ENHANCED_WATCHDOG_TIMER_ENABLE			0x0002
#define sitalConfigurationRegister7_BC_RT_ENHANCED_TIME_TAG_SYNCHRONIZE			0x0004
#define sitalConfigurationRegister7_1553B_RESPONSE_TIME							0x0008
#define sitalConfigurationRegister7_RT_HALT										0x0010

// Interrupt mask register #2 masks.
#define sitalInterruptMaskRegister2_BUILT_IN_TEST_COMPLETE						0x0002
#define sitalInterruptMaskRegister2_BC_INTERRUPT_0								0x0004
#define sitalInterruptMaskRegister2_BC_INTERRUPT_1								0x0008
#define sitalInterruptMaskRegister2_BC_INTERRUPT_2								0x0010
#define sitalInterruptMaskRegister2_BC_INTERRUPT_3								0x0020
#define sitalInterruptMaskRegister2_MT_DATA_STACK_HALF_ROLLOVER					0x0040
#define sitalInterruptMaskRegister2_MT_COMMAND_STACK_HALF_ROLLOVER				0x0080
#define sitalInterruptMaskRegister2_RT_CIRCULAR_BUFFER_HALF_ROLLOVER			0x0100
#define sitalInterruptMaskRegister2_RT_COMMAND_STACK_HALF_ROLLOVER				0x0200
#define sitalInterruptMaskRegister2_BC_TRAP										0x0400
#define sitalInterruptMaskRegister2_BC_CALL_STACK_ERROR							0x0800
#define sitalInterruptMaskRegister2_BC_GENERAL_PURPOSE_QUEUE_ROLLOVER			0x1000
#define sitalInterruptMaskRegister2_RT_INTERRUPT_SERVICE_QUEUE_ROLLOVER			0x1000
#define sitalInterruptMaskRegister2_RT_ILLEGAL_COMMAND							0x2000
#define sitalInterruptMaskRegister2_BC_OPCODE_PARITY_ERROR						0x4000

// Interrupt status register #2 masks.
#define sitalInterruptStatusRegister2_INTERRUPT_CHAIN							0x0001
#define sitalInterruptStatusRegister2_BUILT_IN_TEST_COMPLETE					0x0002
#define sitalInterruptStatusRegister2_BC_ENHANCED_INTERRUPTS_0					0x0004
#define sitalInterruptStatusRegister2_BC_ENHANCED_INTERRUPTS_1					0x0008
#define sitalInterruptStatusRegister2_BC_ENHANCED_INTERRUPTS_2					0x0010
#define sitalInterruptStatusRegister2_BC_ENHANCED_INTERRUPTS_3					0x0020
#define sitalInterruptStatusRegister2_MT_DATA_STACK_HALF_ROLLOVER				0x0040
#define sitalInterruptStatusRegister2_MT_COMMAND_STACK_HALF_ROLLOVER			0x0080
#define sitalInterruptStatusRegister2_RT_CIRCULAR_HALF_ROLLOVER					0x0100
#define sitalInterruptStatusRegister2_RT_COMMAND_STACK_HALF_ROLLOVER			0x0200
#define sitalInterruptStatusRegister2_BC_TRAP_OPCODE							0x0400
#define sitalInterruptStatusRegister2_BC_CALL_STACK_ERROR						0x0800
#define sitalInterruptStatusRegister2_QUEUE_ROLLOVER							0x1000
#define sitalInterruptStatusRegister2_RT_ILLEGAL_COMMAND						0x2000
#define sitalInterruptStatusRegister2_BC_OPCODE_PARITY_ERROR					0x4000
#define sitalInterruptStatusRegister2_MASTER_INTERRUPT							0x8000

// IEEE-1553 constants.
#define sitalIeee1553_SUBADDRESS_COUNT										32		///< The number of subaddresses defined by protocol IEEE-1533.
#define sitalIeee1553_MAXIMUM_COUNT_OF_MESSAGE_DATA_WORDS					32		///< The maximum number of message data words supported by protocol IEEE-1533.

#define sitalIeee1553_Status_TERMINAL_ADDRESS								0xF800	///< The terminal address field mask in the status word of protocol IEEE-1533.
#define sitalIeee1553_Status_OFFSET_OF_TERMINAL_ADDRESS						11		///< The index of the lowest of the bits of the terminal address field mask in the status word of protocol IEEE-1533.
#define sitalIeee1553_Status_ERROR_SECTION									0x07EF	///< The error flags section field mask in the status word of protocol IEEE-1533, i.e., the whole status word excluding the terminal address field and the broadcast command received field.
#define sitalIeee1553_Status_MESSAGE_ERROR									0x0400	///< The message error field mask in the status word of protocol IEEE-1533. Set in case of a data error or an illegal command.
#define sitalIeee1553_Status_INSTRUMENTATION								0x0200	///< The instrumentation field mask in the status word of protocol IEEE-1533. Must be a zero.
#define sitalIeee1553_Status_SERVICE_REQUEST								0x0100	///< The service request field mask in the status word of protocol IEEE-1533. Set only in case the remote terminal requires service.
#define sitalIeee1553_Status_BROADCAST_COMMAND_RECEIVED						0x0010	///< The broadcast command received field mask in the status word of protocol IEEE-1533. Set only in case of a respond to a "Transmit Status Word" or "Transmit Last Command Word" mode code messages, if these are received by a remote terminal right after it received a broadcast message.
#define sitalIeee1553_Status_BUSY											0x0008	///< The busy field mask in the status word of protocol IEEE-1533. Set in case the remote terminal in unable to move data.
#define sitalIeee1553_Status_SUBSYSTEM_FAULT_FLAG							0x0004	///< The subsystem flag field mask in the status word of protocol IEEE-1533. Set in case a fault or failure is identified in any of the subsystems to which the remote terminal is connected.
#define sitalIeee1553_Status_DYNAMIC_BUS_CONTROL_ACCEPTANCE					0x0002	///< The dynamic bus control acceptance field mask in the status word of protocol IEEE-1533. Must be a zero, as dynamic bus control acceptance  isn't supported.
#define sitalIeee1553_Status_TERMINAL_FAULT_FLAG							0x0001	///< The terminal flag field mask in the status word of protocol IEEE-1533. Set in case of a fault of a failure within the remote terminal circuitry.

// General minimums & maximums.
#define sitalMaximum_CARDS										10			///< Maximum number of cards in the system.
#define sitalMinimum_SIZE_OF_RT_AND_MT_DEVICE_MEMORY			4096		///< Minimum size (in words) of RT&MT device memory (must be be divisible by 32).
#define sitalMinimum_SIZE_OF_DEVICE_MEMORY						2048		///< Minimum size (in words) of device memory (must be be divisible by 32).
#define sitalMaximum_SIZE_OF_DEVICE_MEMORY						65536		///< Maximum size (in words) of device memory (must be be divisible by 32).
#define sitalMinimum_SIZE_OF_HOST_BUFFER						4096		///< Minimum size (in words) of a host buffer.
#define sitalMaximum_SIZE_OF_HOST_BUFFER						131072		///< Maximum size (in words) of a host buffer. This constant is smaller than the one offered by DDC ACE in order to save memory, as this library avoids using any dynamic memory allocations, and therefore statically allocates maximal host buffers for all possible devices.
#define sitalMaximum_MESSAGES_IN_HOST_BUFFER					(min(sitalRtMaximum_MESSAGE_SIZE,sitalMtMaximum_MESSAGE_SIZE))	///< Maximum number of messages the may be stored for a RT&MT device in case the maximum possible host buffer has been installed.

// Device IRQ configuration: dwIrqMask values.
#define sitalInterruptRegister1_MASTER_INTERRUPT						0x00008000		///< Master interrupt.
#define sitalInterruptRegister2_INTERRUPT_CHAIN							0x00010000		///< Interrupt chain.
#define sitalInterruptRegister2_MASTER_INTERRUPT						0x80000000		///< Master interrupt.

// BC command distortion: wDistortionManner values.
#define sitalOpcodeDistortion_None					0x0000		///< No command distortion required from now on.
#define sitalOpcodeDistortion_FlipBit				0x0001		///< Flip a specific bit in the command word (the number of the bit to flip, 0-15, is a required parameter).
#define sitalOpcodeDistortion_SetCommand			0x0002		///< Set the command word to a specific value (that value, 0x0000-0xFFFF, is a required parameter).

// Device IRQ configuration: dwIrqMask values.
#define sitalInterruptRegister1_MASTER_INTERRUPT						0x00008000		///< Master interrupt.
#define sitalInterruptRegister2_INTERRUPT_CHAIN							0x00010000		///< Interrupt chain.

// BC counters.
#define sitalBcCounter_GPQ_ENTRIES								32		///< Number of available GPQ entries per BC.
#define sitalBcCounter_ISQ_ENTRIES								32		///< Number of available ISQ entries per BC.
#define sitalBcCounter_COMMANDS									512		///< Number of available user defined commands per BC.
#define sitalBcCounter_FRAME_COMMANDS							128		///< Number of available user defined commands per BC frame.
#define sitalBcCounter_MESSAGES									300		///< Number of available user defined messages per BC.
#define sitalBcCounter_DATA_BLOCKS								300		///< Number of available user defined data blocks per BC.
#define sitalBcCounter_FRAMES									300		///< Number of available user defined frames per BC.

// RT mode code manipulation: wModeCodeType base values.
#define sitalRtModeCodeTypeBase_NO_DATA				0x0000		///< Base value for mode code without data.
#define sitalRtModeCodeTypeBase_DATA				0x0001		///< Base value for mode code with data.
#define sitalRtModeCodeTypeBase_RX					0x0000		///< Base value for mode code Rx.
#define sitalRtModeCodeTypeBase_TX					0x0002		///< Base value for mode code Tx.
#define sitalRtModeCodeTypeBase_NOT_BROADCAST		0x0000		///< Base value for non broadcast mode code.
#define sitalRtModeCodeTypeBase_BROADCAST			0x0004		///< Base value for broadcast mode code.

// RT command stack access: Message location values.
#define sitalMessageLocation_NEXT				0	///< Get the next unread message.
#define sitalMessageLocation_LATEST				2	///< Get the latest message.

// RT command stack access: Message removal values.
#define sitalMessageRemoval_PURGE				0	///< Get the next unread message.
#define sitalMessageRemoval_DO_NOT_PURGE		1	///< Get the latest message.

// BC command creation: wOpcode values.
#define sitalOpcode_FOCUS_ON_VARIABLE				0x0016		///< Focus on variable.
#define sitalOpcode_ADD_TO_VARIABLE					0x0017		///< Add value to the currently focused variable.
#define sitalOpcode_LOAD_TO_VARIABLE				0x0018		///< Load value to the currently focused variable.
#define sitalOpcode_COMPARE_VARIABLE				0x0019		///< Compare the currently focused variable.
#define sitalOpcode_PUSH_VARIABLE					0x001A		///< Focus on variable and push its value to the general purpose queue.



#ifdef __cplusplus
}
#endif



#endif // stld1553_uniqueStldFefinitions_INCLUDED
